//
// Quick and dirty program to convert a G4beamline profile to a ROOT Ntuple
//
// Usage:
//   G4BLProfile f(string filename);
//   TNtuple *n=f.getNtuple();
// The Ntuple will be called "G4BLProfile"
//
//  2014-02-12	E. Prebys	Original
//  2013-02-13  E. Prebys   Changed name
//
#include "G4BLProfile.h"
#include <sstream>

G4BLProfile::G4BLProfile(string fileName) {

      ifstream inFile(fileName.c_str());
     
      string line;
      getline(inFile,line);					// Ignore header line
      getline(inFile,line);  				// Line with column names
      line = line.substr(1);  			 	// Strip leading hashtag

      // Loop over line, get names, and build Ntuple definition string
      stringstream ss(line);
      string nameString="";
      int nNames=0;
      do {
         string name;
         ss>>name;
         nameString+=name;
         nNames++;
         if(!ss.eof()) nameString+=":";
      } while (!ss.eof());
      // Book Ntuple
      n= new TNtuple("G4BLProfile","Profile generated by G4beamline",nameString.c_str());

      getline(inFile,line);  				// Ignore line with units
      
      Float_t *x = new Float_t[nNames];		// Allocate space for variables
	  // Read in each line and fill values into Ntuple
      do {
        getline(inFile,line);
        stringstream ss2(line);
        for(int i=0;i<nNames;i++) {
           ss2>>x[i];
        }
        n->Fill(x);
       } while (!inFile.eof());
       
       // Clean up and exit
       inFile.close();
       delete x;
}
// Extractor for Ntuple pointer
TNtuple *G4BLProfile::getNtuple() {
 return(n);
}